{$ifdef VER55} {$ifndef FAT16} {$error Not FAT32 aware!} {$endif} {$endif}
program zero;
uses dos;
const default=0; drive: byte = default; bufsize = 512*64-512;
  zero1: string[15] = '?:\zero1.dat'; zero2: string[15] = '?:\zero2.dat';
  debug: boolean = false;
type bigdisk = {$ifdef FPC} int64 {$else} longint {$endif} ;
var f,final: file; buf: array [1..bufsize] of byte; avail: bigdisk;

procedure getdrive; var s: string;
const maxdigits=13; const stophere: boolean = false;

  procedure fixname(d: byte); var p: pathstr;
  begin
    if d=0 then begin
      p := fexpand('.'); d := ord(upcase(p[1]))-ord('A')+1
    end;
    zero1[1] := chr(ord('A')+d-1); zero2[1] := zero1[1]
  end; {fixname}

begin
  if paramcount <> 0 then begin s := paramstr(1);
    if ((s = '/test') or (s = '-test')) then
      stophere := true
    else begin
      drive := ord(upcase(s[1]))-ord('A')+1;
      if drive > 26 then drive := 0
    end
  end;
  fixname(drive); avail := diskfree(drive);

  writeln(zero1);
  writeln(avail:maxdigits,' bytes available');
  writeln(disksize(drive):maxdigits,' bytes total');
  if stophere then halt(1)
end; {getdrive}

begin {main} debug := getenv('DEBUG') <> ''; getdrive;
  assign(f,zero1); rewrite(f,bufsize);
  fillchar(buf,bufsize,0);
  while avail >= bufsize do begin
    if debug then writeln(avail);
    blockwrite(f,buf,1); avail := avail - bufsize;
  end;
  if avail > 0 then begin avail := diskfree(drive);
    if debug then writeln('Final = ',avail);
    assign(final,zero2); rewrite(final,avail);
    blockwrite(final,buf,1);
    close(final); if not debug then erase(final)
  end;
  close(f); if not debug then erase(f)
end.
